/* define callback routines */

#include "xfuns.h"
#include "callback.h"

void AddXfun(char *name,char *parms,funptr entry,void (*predef)(),funptr callback)
{
   (*callback)((long)ADDXFUN,name,parms,entry,predef);
}

void AddFunDim(char *name,long lim,funptr callback)
{
   (*callback)((long)ADDFUNDIM,name,lim);
}

void ErrMsg(char *fmt,char *str,funptr callback)
{
   (*callback)((long)ERRMSG,fmt,str);
}

void FreeExpr(EXPR xpr,funptr callback)
{
   (*callback)((long)FREEXPR,xpr);
}

BOOL EvalExpr(EXPR xpr,extended *num,funptr callback)
{
   return((*callback)((long)EVALEXPR,xpr,num));
}

BOOL GetExprMatrix(EXPR xpr,extended **mat,long *cols,long *rows,funptr callback)
{
   return((*callback)((long)GETEXPRMATRIX,xpr,mat,cols,rows));
}

BOOL GetParmVal(long n,extended *num,funptr callback)
{
   return((*callback)((long)GETPARMVAL,(long) n,num));
}

void MakeParmExpr(long n,EXPR *xpr,funptr callback)
{
   (*callback)((long)MAKEPARMEXPR,(long) n,xpr);
}

BOOL ProbeExpr(EXPR xpr,extended *num,BOOL *isarray,long *count,funptr callback)
{
   return((*callback)((long)PROBEXPR,xpr,num,isarray,count));
}

BOOL GetParmName(long n,char **name,funptr callback)
{
   return((*callback)((long)GETPARMNAME,(long) n,name));
}

void AddIndex(EXPR *xpr,extended **iptr,funptr callback)
{
   (*callback)((long)ADDINDEX,xpr,iptr);
}

void RemoveIndex(EXPR *xpr,funptr callback)
{
   (*callback)((long)REMOVEINDEX,xpr);
}

BOOL GetVarVal(char *name,extended *num,funptr callback)
{
   return((*callback)((long)GETVARVAL,name,num));
}

void MakeVarExpr(char *name,EXPR *xpr,funptr callback)
{
   (*callback)((long)MAKEVAREXPR,name,xpr);
}

BOOL SetVarVal(char *name,extended num,funptr callback)
{
   return((*callback)((long)SETVARVAL,name,&num));	/* callback parm must be ptr size */
}

BOOL SetVarMatrix(char *name,extended *arr,long cols,long rows,funptr callback)
{
   return((*callback)((long)SETVARMATRIX,name,arr,cols,rows));
}

void FoldVar(char *name,long lim,funptr callback)
{
   (*callback)((long)FOLDVAR,name,lim);
}

BOOL Stopped(funptr callback)
{
   return((*callback)((long)STOPPED));
}

void SpinWatch(funptr callback)
{
   (*callback)((long)SPINWATCH);
}

